<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.calorie.mapper.food.FoodMapper">
    <resultMap id="FoodMap" type="com.calorie.model.Food">
        <id column="food_id" jdbcType="INTEGER" property="foodId"/>
        <result column="food_name" jdbcType="VARCHAR" property="foodName"/>
        <result column="food_introduction" jdbcType="VARCHAR" property="foodIntroduction"/>
        <result column="food_image" jdbcType="VARCHAR" property="foodImage"/>
        <result column="food_category" jdbcType="VARCHAR" property="foodCategory"/>
        <result column="food_ingredient" jdbcType="VARCHAR" property="foodIngredient"/>
        <result column="food_price" jdbcType="REAL" property="foodPrice"/>
        <result column="food_number" jdbcType="REAL" property="foodNumber"/>
        <result column="food_calorie" jdbcType="REAL" property="foodCalorie"/>
        <result column="food_take_status" property="foodTakeStatus"/>
        <result column="food_shop_id" property="foodShopId"/>
        <result property="foodOrderNumber" column="food_foodorder_food_number"/>

    </resultMap>

    <resultMap id="FoodNumberMap" extends="FoodMap" type="Food">
        <association property="foodOrderNumber" column="food_foodorder_food_number"/>
    </resultMap>

    <select id="selectFoodByShopIdStatus" resultType="Food">
        select *
        from food
        where food_shop_id = #{foodShopId}
          and (food_take_status != 0 or food_take_status is null)

    </select>

    <select id="selectFoodByFoodIdShopId" resultType="Food">
        select *
        from food
        where food_id = #{foodId}
          and food_shop_id = #{shopId}
    </select>


    <select id="selectAllFoodByShopId" resultType="Food">
        select *
        from food
        where food_shop_id = #{foodShopId};

    </select>


    <update id="updateFoodByFoodId">
        update food
        set food_name=#{foodName},
            food_image=#{foodImage},
            food_introduction=#{foodIntroduction},
            food_category=#{foodCategory},
            food_ingredient=#{foodIngredient},
            food_price=#{foodPrice},
            food_number=#{foodNumber},
            food_calorie=#{foodCalorie},
            food_take_status=#{foodTakeStatus},
            food_shop_id=#{foodShopId}
        where food_id = #{foodId}
    </update>

    <update id="updateFoodTakeStatus">
        update food
        set food_take_status=#{foodTakeStatus}
        where food_id = #{foodId}
    </update>


    <insert id="insertNewFood" useGeneratedKeys="true" keyProperty="foodId">
        insert into food (food_name, food_introduction, food_image, food_category, food_ingredient, food_price,
                          food_number,
                          food_calorie, food_take_status, food_shop_id)
        values (#{foodName}, #{foodIntroduction}, #{foodImage}, #{foodCategory}, #{foodIngredient}, #{foodPrice},
                #{foodNumber}, #{foodCalorie}, #{foodTakeStatus}, #{foodShopId});
    </insert>

    <select id="selectAllFood">
        select *
        from food
    </select>


    <!--    <select id="getMaxFoodId" resultType="int">-->
    <!--        select max(food_id)-->
    <!--        from food;-->
    <!--    </select>-->

    <!--    <select id="getMaxNewFoodId" resultType="int">-->
    <!--        select max(food_id)-->
    <!--        from food_censor;-->
    <!--    </select>-->

</mapper>